/*
 *  Copyright 2007, 2008, 2009 eadmaster <spamhereplease@fastwebnet.it>
 *
 *  This library is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; under version 3 of the License.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses>.
 */

#ifndef _SDL_UTILS_
#define _SDL_UTILS_

#include <SDL.h>

/* REMOVE?
typedef struct{
    Sint16 x, y;
} SDL_Point;
typedef SDL_Rect SDL_Point;
*/

void SDL_SetPixel( SDL_Surface* surface, int x, int y, Uint32 pixel ); //Draws the specified color at the specified X and Y on the target surface.
// NO? change in void SDL_SetPixel( SDL_Surface* surface, SDL_Point p, SDL_Color c );

Uint32 SDL_GetPixel( SDL_Surface* surface, int x, int y ); //Returns the color of the specified surface on the specified X and Y coordinates.

//REMOVE? SDL_Surface* SDL_LoadSurface( const char* filename )

inline SDL_Surface* SDL_CloneSurface( SDL_Surface* src )
{
    // TODO: rewrite?
    return SDL_DisplayFormat( src );
}

//TODO? SDL_Rect Intersection( const SDL_Rect r1, const SDL_Rect r2 ); // compute intersection between two rectangles

SDL_Surface* SDL_CreateSurface(Uint16 Width, Uint16 Height); // create an empty SDL surface of given dimensions compatible with the screen
SDL_Surface* SDL_TrimSurface(SDL_Surface* s,  SDL_Rect r); //-> usare con GFX::Rotate()
SDL_Surface* SDL_MergeSurfaces(SDL_Surface* s[]); //-> usare con GFX::Rotate()

void SDL_DrawLine( SDL_Surface* s, Uint32 x1, Uint32 y1, Uint32 x2, Uint32 y2, Uint32 color);

void SDL_ScaleSurface( SDL_Surface *src, SDL_Surface *dst, Uint16 NewWidth, Uint16 NewHeight );

//TODO: void SDL_RotateSurface( SDL_Surface* src, SDL_Surface* dst, double angle );

#endif
